#pragma once

#include "arrowelement.h"
#include "classicnote.h"

#include "initializers/arrownoteinitializer.h"

class ClassicArrowNote : public ClassicNote
{
public:
    enum class Grade
    {
        PERFECT,
           GOOD,
            BAD
    };

    explicit ClassicArrowNote(ArrowNoteInitializer&& init);
    virtual ~ClassicArrowNote() = default;

    virtual bool isActive(const kku::microsec& offset) const override;
    virtual void update(const kku::microsec &music_offset) override;
    virtual void input(kku::GameEvent&& input) override;

    virtual void display(const ClassicGraphicsManager * const manager) const override;
    virtual void setGraphics(ClassicGraphicsManager * const manager, kku::TimeRange&& range) override;

    bool allElementsPressed() const;
    bool isPressedAs(kku::SystemEvent::Key::Code key) const;
    inline bool isHold() const;

private:
    const kku::PrecisionEvaluator<Grade> _evaluator;

    std::vector<ArrowElement> _elements;
    bool _is_hold;
};

using ArrowElements = std::vector<ArrowElement>;
