#pragma once

#include "arrowelement.h"
#include "classicnote.h"

#include "mockelement.h"
#include "initializers/arrownoteinitializer.h"

class ClassicMockNote : public ClassicNote
{
public:
    explicit ClassicMockNote(ArrowNoteInitializer&& init);
    virtual ~ClassicMockNote() = default;

    virtual bool isActive(const kku::microsec& offset) const override;
    virtual void update(const kku::microsec &music_offset) override;
    virtual void input(kku::GameEvent&& input) override;

    virtual void display(const ClassicGraphicsManager * const manager) const override;
    virtual void setGraphics(ClassicGraphicsManager * const manager, kku::TimeRange&& range) override;

private:
    std::vector<MockElement> _elements;
    bool _is_selected;
};

using MockElements = std::vector<MockElement>;
